<?php
	include "inc/settings.inc.php";
	include "classes/database.class.php";
	include "classes/generic.class.php";	
	include "inc/session.inc.php";
		
	$db = new Database();
	$gen = new Generic();
	$settings = $db->getSettings($_SESSION['user_id']);
	$youLess = $db->getYouLess($_SESSION['user_id']);
	
	$startTime = explode(":", $settings['cpkwhlow_start']);
	$endTime = explode (":", $settings['cpkwhlow_end']);
	
	$startSelect = $gen->timeSelector($startTime[0], $startTime[1], 'cpkwhlow_start');
	$endSelect = $gen->timeSelector($endTime[0], $endTime[1], 'cpkwhlow_end');

	$intervalOptions = array(
		'500' => '500',
		'1000' => '1000',
		'2000' => '2000',
		'5000' => '5000'
	);
	$intervalSelect = $gen->selector('liveinterval', $settings['liveinterval'], $intervalOptions);
	$youLessSelect = $gen->selectYouLess('YouLess', '', $youLess);

?>	
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
		<meta name="viewport" content="width=device-width, initial-scale=1"/>		
		<title>YouLess - Energy Monitor</title>
		<link rel="shortcut icon" type="image/x-icon" href="img/favicon.ico" />
		<link type="text/css" href="css/style.min.css" rel="stylesheet" />
		<link type="text/css" href="css/responsive.css" rel="stylesheet" />		
		<script type="text/javascript" src="js/jquery-1.8.2.min.js"></script>
		<script type="text/javascript" src="js/jquery-ui-1.8.23.custom.min.js"></script>
		<script type="text/javascript" src="js/highstock.js"></script>
		<script type="text/javascript" src="js/modules/exporting.js"></script>
		<script type="text/javascript" src="js/script.js"></script>
	</head>
	<body>
	
		<div id="overlay">
			<div id="dialog">
				<div id="message"></div>
				<input type="button" id="closeDialog" value="Sluiten"/>
			</div>
			<div id="overlayBack"></div>
		</div>
		<div id="settingsOverlay" data-dualcount="<?php echo $settings['dualcount']; ?>" data-liveinterval="<?php echo $settings['liveinterval']; ?>">
			<form>
				<table>
					<tr>
						<td style="width:200px;">Meter type:</td><td>Enkel<input type="radio" name="dualcount" value="0" <?php echo ($settings['dualcount'] == 0 ? 'checked=checked' : '') ?>/> Dubbel<input type="radio" name="dualcount" value="1" <?php echo ($settings['dualcount'] == 1 ? 'checked=checked' : '') ?>/></td>
					</tr>				
					<tr>
						<td>Prijs per kWh:</td><td><input type="text" name="cpkwh" value="<?php echo $settings['cpkwh']; ?>"/></td>
					</tr>
					<tr class="cpkwhlow" <?php echo ($settings['dualcount'] == 1 ? '' : 'style="display:none;"') ?>;>
						<td>Prijs per kWh (laagtarief):</td><td><input type="text" name="cpkwh_low" value="<?php echo $settings['cpkwh_low']; ?>"/></td>
					</tr>	
					<tr class="cpkwhlow" <?php echo ($settings['dualcount'] == 1 ? '' : 'style="display:none;"') ?>;>
						<td>Tijd laagtarief:</td><td><?php echo $startSelect; ?> tot <?php echo $endSelect; ?></td>
					</tr>
					<tr>
						<td>Update interval live weergave:</td><td><?php echo $intervalSelect; ?> ms</td>
					</tr>															
					<tr>
						<td>Gebruikersnaam:</td><td><input type="text" name="username" value="<?php echo $settings['username']; ?>"/></td>
					</tr>
					<tr>
						<td>Wachtwoord:</td><td><input type="password" name="password" value=""/></td>
					</tr>										
					<tr>
						<td>Bevestig wachtwoord:</td><td><input type="password" name="confirmpassword" value=""/></td>
					</tr>										
					<tr>
						<td><input type="submit" id="saveSettings" value="Opslaan"/></td><td><input type="button" id="hideSettings" value="Sluiten"/></td>
					</tr>
				</table>
			</form>	

			<div id="version">v1.3.2</div>
		</div>
		<div id="youlessOverlay">
			<form>
				<table>
					<tr>
						<td style="width:150px;">YouLess apparaten:</td><td><?php echo $youLessSelect; ?></td><td><input type="button" id="upYouless" value="&and;"/><input type="button" id="downYouless" value="&or;"/></td>
					</tr>
					<tr>
						<td colspan="2">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input type="button" id="addYouless" value="Toevoegen"/>&nbsp;&nbsp;<input type="button" id="editYouless" value="Bewerken"/>&nbsp;&nbsp;<input type="button" id="delYouless" value="Verwijderen"/></td>
					</tr>
					<tr>
						<td>&nbsp;</td><td colspan="2"><input type="button" id="hideYouless" value="Sluiten"/></td>
					</tr>
				</table>
			</form>
		</div>
		<div id="youlessAddOverlay">
			<form>
				<table>
					<tr>
						<td>Youless naam:</td><td><input type="text" name="friendly_name" value=""/></td>
					</tr>
					<tr>
						<td>Youless adres:</td><td><input type="text" name="YL_address" value=""/></td>
					</tr>
					<tr>
						<td>Youless poort:</td><td><input type="text" name="YL_port" value=""/></td>
					</tr>
					<tr>
						<td>Youless wachtwoord:</td><td><input type="text" name="YL_password" value=""/></td>
					</tr>
					<tr>
						<td>&nbsp;</td><td><input type="button" id="hideAddYoulessAdd" value="Toevoegen"/>&nbsp;&nbsp;<input type="button" id="hideAddYouless" value="Sluiten"/></td>
					</tr>
				</table>
			</form>
		</div>
		<div id="topHeader">
			<div id="youless"><a href="#" id="showYouless">Apparaten</a></div>
			<div id="settings"><a href="#" id="showSettings">Instellingen</a></div>
			<div id="logout"><a href="?logout=1">Logout</a></div>
		</div>
		<div id="header">
		
			<div id="logo"></div>
		
			<div id="menu">
				<ul class="btn">
					<li class="selected"><a href="#" data-chart="live" class="showChart">Live</a></li>
					<li><a href="#" data-chart="day" class="showChart">Dag</a></li>
					<li><a href="#" data-chart="week" class="showChart">Week</a></li>
					<li><a href="#" data-chart="month" class="showChart">Maand</a></li>
				</ul>
			</div>
			
			<div id="cpkwhCounter" class="counter chart day week month"></div>
			<div id="wattCounter" class="counter chart live"></div>
			<div id="kwhCounter" class="counter chart day week month" style="display:none;"></div>
		</div>
		<div id="container">
			<div id="datepickContainer" class="chart day week month">
				<input type="text" id="datepicker" value="<?php echo date("Y-m-d"); ?>">			
			</div>
			<div id="history" class="chart day week month"></div>
			<div id="live" class="chart live" style="height: 500px; min-width: 500px;"></div>

		</div>
	</body>
</html>
